// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Map.proto
#ifdef _MSC_VER
#pragma warning(disable:4125)
#endif
#include "Map.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/io/zero_copy_stream_impl_lite.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)

namespace protobuf_Material_2eproto {
extern PROTOBUF_INTERNAL_EXPORT_protobuf_Material_2eproto ::google::protobuf::internal::SCCInfo<0> scc_info_Material;
}  // namespace protobuf_Material_2eproto
namespace dfproto {
class MapDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<Map>
      _instance;
} _Map_default_instance_;
}  // namespace dfproto
namespace protobuf_Map_2eproto {
static void InitDefaultsMap() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::dfproto::_Map_default_instance_;
    new (ptr) ::dfproto::Map();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::dfproto::Map::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<1> scc_info_Map =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 1, InitDefaultsMap}, {
      &protobuf_Material_2eproto::scc_info_Material.base,}};

void InitDefaults() {
  ::google::protobuf::internal::InitSCC(&scc_info_Map.base);
}

}  // namespace protobuf_Map_2eproto
namespace dfproto {

// ===================================================================

void Map::InitAsDefaultInstance() {
}
void Map::clear_inorganic_material() {
  inorganic_material_.Clear();
}
void Map::clear_organic_material() {
  organic_material_.Clear();
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int Map::kXSizeFieldNumber;
const int Map::kYSizeFieldNumber;
const int Map::kZSizeFieldNumber;
const int Map::kInorganicMaterialFieldNumber;
const int Map::kOrganicMaterialFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

Map::Map()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_Map_2eproto::scc_info_Map.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:dfproto.Map)
}
Map::Map(const Map& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      inorganic_material_(from.inorganic_material_),
      organic_material_(from.organic_material_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&x_size_, &from.x_size_,
    static_cast<size_t>(reinterpret_cast<char*>(&z_size_) -
    reinterpret_cast<char*>(&x_size_)) + sizeof(z_size_));
  // @@protoc_insertion_point(copy_constructor:dfproto.Map)
}

void Map::SharedCtor() {
  ::memset(&x_size_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&z_size_) -
      reinterpret_cast<char*>(&x_size_)) + sizeof(z_size_));
}

Map::~Map() {
  // @@protoc_insertion_point(destructor:dfproto.Map)
  SharedDtor();
}

void Map::SharedDtor() {
}

void Map::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const Map& Map::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_Map_2eproto::scc_info_Map.base);
  return *internal_default_instance();
}


void Map::Clear() {
// @@protoc_insertion_point(message_clear_start:dfproto.Map)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  inorganic_material_.Clear();
  organic_material_.Clear();
  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 7u) {
    ::memset(&x_size_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&z_size_) -
        reinterpret_cast<char*>(&x_size_)) + sizeof(z_size_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool Map::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:dfproto.Map)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required uint32 x_size = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_x_size();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &x_size_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required uint32 y_size = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_y_size();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &y_size_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required uint32 z_size = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          set_has_z_size();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &z_size_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .dfproto.Material inorganic_material = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(34u /* 34 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
                input, add_inorganic_material()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .dfproto.Material organic_material = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(42u /* 42 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
                input, add_organic_material()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:dfproto.Map)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:dfproto.Map)
  return false;
#undef DO_
}

void Map::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:dfproto.Map)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required uint32 x_size = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(1, this->x_size(), output);
  }

  // required uint32 y_size = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(2, this->y_size(), output);
  }

  // required uint32 z_size = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(3, this->z_size(), output);
  }

  // repeated .dfproto.Material inorganic_material = 4;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->inorganic_material_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      4,
      this->inorganic_material(static_cast<int>(i)),
      output);
  }

  // repeated .dfproto.Material organic_material = 5;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->organic_material_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessage(
      5,
      this->organic_material(static_cast<int>(i)),
      output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:dfproto.Map)
}

size_t Map::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:dfproto.Map)
  size_t total_size = 0;

  if (has_x_size()) {
    // required uint32 x_size = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->x_size());
  }

  if (has_y_size()) {
    // required uint32 y_size = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->y_size());
  }

  if (has_z_size()) {
    // required uint32 z_size = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->z_size());
  }

  return total_size;
}
size_t Map::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:dfproto.Map)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (((_has_bits_[0] & 0x00000007) ^ 0x00000007) == 0) {  // All required fields are present.
    // required uint32 x_size = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->x_size());

    // required uint32 y_size = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->y_size());

    // required uint32 z_size = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->z_size());

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  // repeated .dfproto.Material inorganic_material = 4;
  {
    unsigned int count = static_cast<unsigned int>(this->inorganic_material_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->inorganic_material(static_cast<int>(i)));
    }
  }

  // repeated .dfproto.Material organic_material = 5;
  {
    unsigned int count = static_cast<unsigned int>(this->organic_material_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->organic_material(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void Map::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const Map*>(&from));
}

void Map::MergeFrom(const Map& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:dfproto.Map)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  inorganic_material_.MergeFrom(from.inorganic_material_);
  organic_material_.MergeFrom(from.organic_material_);
  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 7u) {
    if (cached_has_bits & 0x00000001u) {
      x_size_ = from.x_size_;
    }
    if (cached_has_bits & 0x00000002u) {
      y_size_ = from.y_size_;
    }
    if (cached_has_bits & 0x00000004u) {
      z_size_ = from.z_size_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void Map::CopyFrom(const Map& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:dfproto.Map)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool Map::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000007) != 0x00000007) return false;
  if (!::google::protobuf::internal::AllAreInitialized(this->inorganic_material())) return false;
  if (!::google::protobuf::internal::AllAreInitialized(this->organic_material())) return false;
  return true;
}

void Map::Swap(Map* other) {
  if (other == this) return;
  InternalSwap(other);
}
void Map::InternalSwap(Map* other) {
  using std::swap;
  CastToBase(&inorganic_material_)->InternalSwap(CastToBase(&other->inorganic_material_));
  CastToBase(&organic_material_)->InternalSwap(CastToBase(&other->organic_material_));
  swap(x_size_, other->x_size_);
  swap(y_size_, other->y_size_);
  swap(z_size_, other->z_size_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string Map::GetTypeName() const {
  return "dfproto.Map";
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace dfproto
namespace google {
namespace protobuf {
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::dfproto::Map* Arena::CreateMaybeMessage< ::dfproto::Map >(Arena* arena) {
  return Arena::CreateInternal< ::dfproto::Map >(arena);
}
}  // namespace protobuf
}  // namespace google

// @@protoc_insertion_point(global_scope)
